        program crndat

C Takes a dataset in Cornell condensed format and converts it to database format
C Dimensioned for 200000 samples and 200000 species
        parameter (ninam=10,nnite=40,nc=80)
        parameter (nsmpmx=200000,nspmax=200000)
        parameter (nnrow=(nsmpmx+9)/10+(nspmax+9)/10)
        common/com1/tnam
        common/com2/lshort
        common/com3/lsamp

        integer iisp(nnite),iorder(nsmpmx),jorder(nspmax)
        real quant(nnite)
        character*1 a1(80),a2(80),blank1,s1(8),s2(9),undsco/'_'/
        character*20 filein,fileou,blnk20
        character*30 fmt
        character*2 col70
        character*4 gen,sp
        character*8 lnam(ninam),blank8,lsamp(nsmpmx),badsam(nsmpmx)
        character*8 tnam(nnrow,ninam)
        character*8 sh,sh1
        character*9 short,short1,lshort(nspmax),badsp(nspmax),blank9
        equivalence (sh,s1),(short,s2)

        data blank8/'        '/
        data blank9/'         '/,blank1/' '/
        data blnk20/'                    '/

        print 2062
 2062 format(1x,'Program CORNDATA, written by M.O. Hill, Sept 2011'//
     1    1x,'Converts Cornell Condensed format to database format'//)
        goto 42
   40   continue
        print 2065
 2065 format(1x,'*** ERROR ***  file does not exist'/
     1       ' Type another name')
   42   continue
        print 2070
 2070 format(1x,'Type name of input file (Cornell format) ...')
        read(*,1001) filein
        open(unit=3,file=filein,status='old',err=40)
        print 2071
 2071 format(1x,'Type name of output file (database format)'/
     1       1x,'or press <RETURN> for default = SAMPLES.DAT')
 1001 format(a20)
        read(*,1001) fileou
C In default case, test for whether SAMPLES.DAT already exists
        if(fileou.eq.blnk20) then
          open(unit=10,file='SAMPLES.DAT',status='new',
     1         err=997)
          else
          open(unit=10,file=fileou,status='new')
          end if

        read(3,1000,end=999) (a1(ic),ic=1,nc)
 1000 format(80a1)
        read(3,1000,end=999) (a2(ic),ic=1,nc)
        do 50 icc=1,20
                if(a2(icc).ne.blank1) goto 55
   50           continue
   55   write(fmt,3000) (a2(ic),ic=icc,30+icc-1)
 3000 format(30a1)
        print 2501, fmt
 2501 format(1x,a30)
        write(col70,3001) (a2(ic),ic=69,70)
 3001 format(2a1)
        nitem=0
        read(col70,3002,err=110) nitem
 3002 format(i2)
  110   continue
        read(3,*,err=111) nnitem
  111   continue
        read(3,fmt,err=998) isamp,iisp(1),quant(1)
        if (nitem.gt.0) then
          if(nnitem.ne.1) print 2000
 2000 format(/1x,'Beware - number of items seems to be',i4/
     1        1x,'yet first number on next card is    ',i4)
          nstart=2
          goto 190
          end if
        if (nitem.eq.0.and.nnitem.gt.1) then
          nstart=3
          nitem=nnitem
          goto 190
          end if
C In this case we are a bit lost, because we do not know how many
C items per line
        print 2001
 2001 format(/1x,'Number of couplets per line is taken to be 1'/
     1      1x,'If wrong, put desired number as card 3 of data'/
     2      1x,'Press <RETURN> to continue')
        read(*,*)

  190     rewind(3)
          if(nitem.ne.1) print 2002,nitem
 2002 format(/1x,'Number of couplets per line is',i3)
          do 195 istart=1,nstart
               read(3,*)
  195          continue

          nsp=0
          nsamp=0
          iisamp=0
          ierr=0
  200     read(3,fmt) isamp,(iisp(item),quant(item),item=1,nitem)
          if(isamp.eq.0) goto 290
          if(isamp.ne.iisamp) then
               irem=mod(isamp,100)
               if(irem.eq.0) print *,'Reading sample ',isamp
               if(isamp.ne.iisamp+1) then
                    print 2003,iisamp,isamp
 2003 format(1x,'*** BEWARE *** Non-sequential sample numbers',2i6)
                    ierr=ierr+1
                    if(ierr.lt.2) then
                         print 2056
 2056 format(/1x,'Press <RETURN> to continue')
                         read(*,*)
                         end if
                    end if
               iisamp=isamp
               nsamp=isamp
               end if
          do 210 item=1,nitem
               if(iisp(item).gt.nsp) nsp=iisp(item)
  210          continue
          if(nsp.gt.nspmax) then
               print 2004,nsp,nspmax
 2004 format(//1x,'*** ERROR ***  Species number',i6,'exceeds',i6/
     1         1x,'Program must be redimensioned and recompiled')
               call hold
               stop
               end if
          if(nsamp.gt.nsmpmx) then
               print 2005,nsamp,nsmpmx
 2005 format(//1x,'*** ERROR ***  Sample number',i6,'exceeds',i6/
     1         1x,'Program must be redimensioned and recompiled')
               call hold
               stop
               end if
          goto 200
  290     continue
          lin=0
          print 2007,nsp
 2007 format(/1x,'Highest species number in data matrix is',i6)
          print 2008,nsamp
 2008 format(1x,'Highest sample number in data matrix is ',i6/)
          n1=(nsp+9)/10
          n2=(nsamp+9)/10
          if(n1+n2.gt.nnrow) then
               nnnn=(n1+n2)*ninam
               nsum=nsp+nsamp
               print 2009,nsum,nnnn
 2009 format(//1x,'*** ERROR *** Number of spp + samples is',i5,
     1     1x,'but cannot exceed',i5/1x,'Redimension and recompile')
               call hold
               stop
               end if
  300     read(3,1010,end=390) (lnam(inam),inam=1,ninam)
 1010 format(10a8)
          lin=lin+1
          do 310 inam=1,ninam
               tnam(lin,inam)=lnam(inam)
  310          continue
          goto 300

  390     continue
          if (lin.lt.n1) then
               print 2999
 2999 format(//1x,'*** Not enough species names ***')
               call hold
               stop
               end if
          if (lin.gt.n1+n2) then
C This is case where apparently too many names;  register sample names
C at the end
               if (mod(nsp,10).ne.0) then
                    if(tnam(n1,10).eq.blank8.and.tnam(n1+1,1).ne.blank8)
     1                   goto 400
                    end if
               ndiff=lin-n1-n2
               do 395 idiff=1,ndiff
                    do 393 inam=1,ninam
                         if (tnam(lin-idiff+1,inam).ne.blank8) goto 396
  393                    continue
  395               continue
C In this case the only problem is trailing blank lines
               goto 400
  396          continue
               do 397 i=n1+1,lin-n2-idiff+1
                    if(tnam(i,ninam).eq.blank8.and.tnam(i+1,1).ne.
     1                   blank8) then
                         n1=i
                         goto 400
                         end if
  397               continue
               n1=lin-n2-idiff+1
               end if
  400     continue
C We now write the names to the appropriate files
          isp=0
          do 410 i1=1,n1
               do 405 inam=1,ninam
                    isp=isp+1
                    sh=tnam(i1,inam)
                    read(sh,3010) gen,sp
 3010 format(2a4)
                    write(short,3011) gen,sp
 3011 format(a4,1x,a4)
                    if (short.eq.blank9) write(short,3012)
 3012 format('No Name  ')
                    lshort(isp)=short
  405               continue
  410          continue

          if (lin.lt.n1+n2) n2=lin-n1
          isamp=0
          do 420 i2=1,n2
               do 415 inam=1,ninam
                    isamp=isamp+1
                    sh=tnam(i2+n1,inam)
                    if(sh.eq.blank8) write(sh,3013)
                    lsamp(isamp)=sh
 3013 format('No Name ')
  415               continue
  420          continue
          rewind(3)

C lshort and lsamp now contain the lists of names
C process them to replace blanks by underscores
          do isamp=1,nsamp
             sh=lsamp(isamp)
             do kk=1,8
                if(s1(kk).eq.blank1) s1(kk)=undsco
                lsamp(isamp)=sh
                enddo
             enddo
          do isp=1,nsp
             short=lshort(isp)
             do kk=1,9
                if(s2(kk).eq.blank1) s2(kk)=undsco
                lshort(isp)=short
                enddo
             enddo
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Disambiguate samples if name repeated
          mbad=0
          do isamp=1,nsamp
             iorder(isamp)=isamp
             enddo
  423     continue
          call sort28(lsamp,iorder,nsamp)
          ii=0
          do isamp=2,nsamp
             if(lsamp(isamp).ne.lsamp(isamp-1)) then
                ii=0
                else
  425           continue
                ii=ii+1
                if(ii.gt.9) then
                   print 2554,lsamp(isamp)
 2554 format(/'*** Too many repeats of sample name ',a8,
     1       ' ***'/)
                   call hold
                   stop
                   end if
                sh=lsamp(isamp)
                write(s1(8),2555) ii
 2555 format(i1)
C Check for whether this name already exists
                do isamp1=1,nsamp
                   if(lsamp(isamp1).eq.sh) goto 425
                   enddo
C Check for whether sh is on the bad list and skip the next segment if it is
                do ibad=1,mbad
                   if(lsamp(isamp).eq.badsam(ibad)) goto 461
                   enddo
                sh1=sh
                write(s1(8),2555) 0
C Check for whether this exists and if it does not then list it
                do isamp1=1,nsamp
                   if(lsamp(isamp1).eq.sh) goto 460
                   enddo
                print 2556,lsamp(isamp),sh
  460           continue                   
                sh=sh1
  461           continue
                print 2556,lsamp(isamp),sh
 2556 format('RECODED ',a8,' as ',a8)
                lsamp(isamp)=sh
C Store the bad repeated name
                if(mbad.eq.0) then
                   mbad=mbad+1
                   badsam(mbad)=lsamp(isamp-1)
                   else
                   if(badsam(mbad).ne.lsamp(isamp-1)) then
                      mbad=mbad+1
                      badsam(mbad)=lsamp(isamp-1)
                      end if
                   end if                   
                goto 423
                end if
             enddo
          do ibad=1,mbad
             sh=badsam(ibad)
             do isamp=1,nsamp
                if(lsamp(isamp).eq.sh) then
                   write(s1(8),2555) 0
C Check for whether this exists and if it does not then use it
                   do isamp1=1,nsamp
                      if(lsamp(isamp1).eq.sh) goto 427
                      enddo
                   lsamp(isamp)=sh
                   goto 427
                   end if
                enddo                
  427        continue
             enddo
C Put back in correct order
          call sort82(iorder,lsamp,nsamp)         
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

C Disambiguate species if name repeated
          nbad=0
          do isp=1,nsp
             jorder(isp)=isp
             enddo
  433     continue
          call sort29(lshort,jorder,nsp)
          ii=0
          do isp=2,nsp
             if(lshort(isp).ne.lshort(isp-1)) then
                ii=0
                else
  435           continue
                ii=ii+1
                if(ii.gt.9) then
                   print 2654,lshort(isp)
 2654 format(/'*** Too many repeats of species name ',a9,
     1       ' ***'/)
                   call hold
                   stop
                   end if
                short=lshort(isp)
                write(s2(9),2555) ii
C Check for whether this name already exists
                do isp1=1,nsp
                   if(lshort(isp1).eq.short) goto 435
                   enddo
C Check whether the name that produced it is on the bad list
                do jbad=1,nbad
                   if(lshort(isp).eq.badsp(jbad)) goto 471
                   enddo
                short1=short
                write(s2(9),2555) 0
C Check for whether this exists and if it does not then list it
                do isp1=1,nsp
                   if(lshort(isp1).eq.short) goto 470
                   enddo
                print 2656,lshort(isp),short
  470           continue                   
                short=short1
  471           continue
                print 2656,lshort(isp),short
 2656 format('RECODED ',a9,' as ',a9)
                lshort(isp)=short
                if(nbad.eq.0) then
                   nbad=nbad+1
                   badsp(nbad)=lshort(isp-1)
                   else
                   if(badsp(nbad).ne.lshort(isp-1)) then
                      nbad=nbad+1
                      badsp(nbad)=lshort(isp-1)
                      end if
                   end if                   
                goto 433
                end if
             enddo
          do jbad=1,nbad
             short=badsp(jbad)
             do isp=1,nsp
                if(lshort(isp).eq.short) then
                   write(s2(9),2555) 0
C Check for whether this exists and if it does not then use it
                   do isp1=1,nsp
                      if(lshort(isp1).eq.short) goto 437
                      enddo
                   lshort(isp)=short
                   goto 437
                   end if
                enddo
  437        continue
             enddo
C Put back in correct order
          call sort92(jorder,lshort,nsp)         
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Now work through data
          ndata=0
          do 495 istart=1,nstart
               read(3,*)
  495          continue
          iisamp=0
  500     continue
          read(3,fmt) isamp,(iisp(item),quant(item),item=1,nitem)
          if(isamp.eq.0) goto 999
          iisamp=isamp
          do 550 item=1,nitem
               isp=iisp(item)
               if (isp.eq.0) goto 550
               short=lshort(isp)
               ndata=ndata+1
               write(10,2032) lsamp(isamp),short,quant(item)
 2032 format(a8,1x,a9,2x,f6.1)
  550          continue
          goto 500

  997     continue
C This is the case where we are trying to open a file SAMPLES.DAT for
C writing and this may not be possible if this file already exists
          print 2997
 2997 format(//1x,'** ERROR ** Cannot open SAMPLES.DAT for writing'/
     1         1x,'Delete or change name of existing file of that name')
          call hold
          stop

  998     continue
C This is the case where the card on line 4 does not seem to have right
C format, or format statement is wrong
          print 2039
 2039 format(//1x,'*** Error *** Format on card 2 has wrong syntax',
     1        /1x,'              or data on card 4 do not fit format')
          call hold
          stop

  999     continue
          write(10,2040)
 2040 format(1x)
          print 2042,ndata
 2042 format(/'Length of data array ',i8//1x,'End of data')
          close(3)
          close(10)
          call hold
          stop
          end

      subroutine hold
C Asks for user input before exiting, to retain DOS window
      character*1 ch
      write(*,2000)
 2000 format(////'*** Program finished  ***'///
     1       'Press <RETURN> to exit'///
     2              '*************************')
      read(*,1000) ch
 1000 format(a1)
      return
      end

      subroutine sort28(dict,type,n)
C To sort two columns at once; the integers being driven by the character*8 ones
      character*8 dict(n),djx,djjx,djjjx
      integer type(n),tjx,tjjx,tjjjx,i,j,jj,jjj
      do 10 i=1,n
      j=i
      djx=dict(j)
      tjx=type(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=dict(jj)
      tjjx=type(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.eq.djx) then
           if(tjjx.ge.tjx) goto 8
           end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      goto 5
    8 dict(j)=djx
      type(j)=tjx
   10 continue
      i=n
      goto 14
   12 dict(j)=djx
      type(j)=tjx
   14 if(i.eq.1) return
      djx=dict(i)
      tjx=type(i)
      dict(i)=dict(1)
      type(i)=type(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=dict(jj)
      tjjx=type(jj)
      jjj=jj+1
      djjjx=dict(jjj)
      tjjjx=type(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.eq.djjjx) then
          if(tjjx.ge.tjjjx) goto 18
          end if
      if(djx.gt.djjjx) goto 12
      if(djx.eq.djjjx) then
          if(tjx.ge.tjjjx) goto 12
          end if
      dict(j)=djjjx
      type(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=dict(jj)
      tjjx=type(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.eq.djjx) then
          if(tjx.ge.tjjx) goto 12
          end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end

      subroutine sort82(dict,type,n)
C To sort two columns at once; the character*8 ones being driven by integers
      integer dict(n),djx,djjx,djjjx,i,j,jj,jjj
      character*8 type(n),tjx,tjjx,tjjjx
      do 10 i=1,n
      j=i
      djx=dict(j)
      tjx=type(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=dict(jj)
      tjjx=type(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.eq.djx) then
           if(tjjx.ge.tjx) goto 8
           end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      goto 5
    8 dict(j)=djx
      type(j)=tjx
   10 continue
      i=n
      goto 14
   12 dict(j)=djx
      type(j)=tjx
   14 if(i.eq.1) return
      djx=dict(i)
      tjx=type(i)
      dict(i)=dict(1)
      type(i)=type(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=dict(jj)
      tjjx=type(jj)
      jjj=jj+1
      djjjx=dict(jjj)
      tjjjx=type(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.eq.djjjx) then
          if(tjjx.ge.tjjjx) goto 18
          end if
      if(djx.gt.djjjx) goto 12
      if(djx.eq.djjjx) then
          if(tjx.ge.tjjjx) goto 12
          end if
      dict(j)=djjjx
      type(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=dict(jj)
      tjjx=type(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.eq.djjx) then
          if(tjx.ge.tjjx) goto 12
          end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end

      subroutine sort29(dict,type,n)
C To sort two columns at once; the integers being driven by the character*9 ones
      character*9 dict(n),djx,djjx,djjjx
      integer type(n),tjx,tjjx,tjjjx,i,j,jj,jjj
      do 10 i=1,n
      j=i
      djx=dict(j)
      tjx=type(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=dict(jj)
      tjjx=type(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.eq.djx) then
           if(tjjx.ge.tjx) goto 8
           end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      goto 5
    8 dict(j)=djx
      type(j)=tjx
   10 continue
      i=n
      goto 14
   12 dict(j)=djx
      type(j)=tjx
   14 if(i.eq.1) return
      djx=dict(i)
      tjx=type(i)
      dict(i)=dict(1)
      type(i)=type(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=dict(jj)
      tjjx=type(jj)
      jjj=jj+1
      djjjx=dict(jjj)
      tjjjx=type(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.eq.djjjx) then
          if(tjjx.ge.tjjjx) goto 18
          end if
      if(djx.gt.djjjx) goto 12
      if(djx.eq.djjjx) then
          if(tjx.ge.tjjjx) goto 12
          end if
      dict(j)=djjjx
      type(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=dict(jj)
      tjjx=type(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.eq.djjx) then
          if(tjx.ge.tjjx) goto 12
          end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end

      subroutine sort92(dict,type,n)
C To sort two columns at once; the character*9 one being driven by integers
      integer dict(n),djx,djjx,djjjx,i,j,jj,jjj
      character*9 type(n),tjx,tjjx,tjjjx
      do 10 i=1,n
      j=i
      djx=dict(j)
      tjx=type(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=dict(jj)
      tjjx=type(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.eq.djx) then
           if(tjjx.ge.tjx) goto 8
           end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      goto 5
    8 dict(j)=djx
      type(j)=tjx
   10 continue
      i=n
      goto 14
   12 dict(j)=djx
      type(j)=tjx
   14 if(i.eq.1) return
      djx=dict(i)
      tjx=type(i)
      dict(i)=dict(1)
      type(i)=type(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=dict(jj)
      tjjx=type(jj)
      jjj=jj+1
      djjjx=dict(jjj)
      tjjjx=type(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.eq.djjjx) then
          if(tjjx.ge.tjjjx) goto 18
          end if
      if(djx.gt.djjjx) goto 12
      if(djx.eq.djjjx) then
          if(tjx.ge.tjjjx) goto 12
          end if
      dict(j)=djjjx
      type(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=dict(jj)
      tjjx=type(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.eq.djjx) then
          if(tjx.ge.tjjx) goto 12
          end if
      dict(j)=djjx
      type(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end
