C DECORANA VERSION 1.2, WRITTEN BY M.O.HILL 1979, REVISED 1994 and 2012
C
C PERFORMS DETRENDED CORRESPONDENCE ANALYSIS;  ALSO WILL DO RECIPROCAL
C AVERAGING AS A SPECIAL CASE.
C
C DIMENSIONED FOR maxsam SAMPLES, maxspe SPECIES, maxdat NON-ZERO ITEMS
C IN DATA MATRIX.  [Originally these were 700,500,7000]
C INPUT DEVICES ARE 8 (DATA MATRIX)  AND * (CONSOLE)
C OUTPUT DEVICES ARE 9 (MAIN OUTPUT) AND * (CONSOLE)
C
      parameter (maxsam=9999,maxspe=9999,maxdat=3000000,nscrn=23)
      character*4 TITLE(20)
      character*20 filein,fileou
      character*65 xlist(nscrn)
      REAL XEIG1(maxsam),XEIG2(maxsam),XEIG3(maxsam),XEIG4(maxsam),
     1   AIDOT(maxsam)
      INTEGER IBEGIN(maxsam),IEND(maxsam),INAME1(maxsam),INAME2(maxsam)
      INTEGER IXX0(maxsam)
      INTEGER IX1(maxsam),IX2(maxsam),IX3(maxsam),IX4(maxsam)
      INTEGER IXX1(maxsam),IXX2(maxsam),IXX3(maxsam),IXX4(maxsam)
      INTEGER INFLAG(maxsam)
      REAL Y2(maxspe),Y3(maxspe),Y4(maxspe),Y5(maxspe),V(maxspe)
      REAL YEIG1(maxspe),YEIG2(maxspe),YEIG3(maxspe),YEIG4(maxspe),
     1   ADOTJ(maxspe)
      INTEGER JNAME1(maxspe),JNAME2(maxspe),JNFLAG(maxspe)
      INTEGER IYY0(maxspe)
      INTEGER IY1(maxspe),IY2(maxspe),IY3(maxspe),IY4(maxspe)
      INTEGER IYY1(maxspe),IYY2(maxspe),IYY3(maxspe),IYY4(maxspe)
      REAL QIDAT(maxdat)
      INTEGER IDAT(maxdat)
      REAL BEFORE(50),AFTER(50)
      equivalence (IXX0(1),AIDOT(1))
      EQUIVALENCE (IXX1(1),XEIG1(1)),(IXX2(1),XEIG2(1))
      EQUIVALENCE (IXX3(1),XEIG3(1)),(IXX4(1),XEIG4(1))
      EQUIVALENCE (IYY0(1),ADOTJ(1))
      EQUIVALENCE (IYY1(1),YEIG1(1)),(IYY2(1),YEIG2(1))
      EQUIVALENCE (IYY3(1),YEIG3(1)),(IYY4(1),YEIG4(1))
      EQUIVALENCE (IY4(1),V(1)),(JNFLAG(1),IDAT(1))
      MMAX=maxsam
      NMAX=maxspe
      IDMAX=maxdat

      call screen(xlist,nscrn)
          do 3 i=1,8
               write(*,*)
    3          continue
          write(*,2000) maxsam,maxspe,maxdat
 2000 format(1x,'RUNNING DECORANA VERSION 1.2'//
     1    1x,'Dimensioned for maximum'/
     2    5x,i6,' samples'/5x,i6,' species'/
     3    3x,i8,' non-zero items in datamatrix')
      write(*,2476)
 2476 format(//1x,'Enter name of file with input data ',
     1    '(Cornell Condensed Format)')

  900 continue
      call prompt
      read(*,2477) filein
 2477 format(a20)
 2478 format(1x,a20)
      open(unit=8,file=filein,status='old',err=999)
      write(*,2479)
 2479 format(//1x,'Enter name of file with answers')
  800 continue
      call prompt
      read(*,2477) fileou
      open(unit=9,file=fileou,status='new',err=899)
      write(9,2476)
      write(9,2478) filein
      write(9,2479)
      write(9,2478) fileou

        write(*,2005)
        write(9,2005)
 2005 format(//1x,'Additional output of axis scores ',
     1         '(e.g. for plotting)'/
     1     12x,'0= No additional output (default)'/
     2     12x,'1= Axis scores written to separate files')
        call getnum(iaxout,0,0,1)
        if(iaxout.eq.1) then
          write(*,2006)
 2006 format(//1x,'Enter name of file with species scores')
          goto 799
  798     continue
          write(*,*) ' *** FILE ALREADY EXISTS - TYPE ANOTHER NAME ***'
  799     continue
          call prompt
          read(*,2477) fileou
          open(unit=10,file=fileou,status='new',err=798)
          write(9,2006)
          write(9,2478) fileou
          write(*,2007)
 2007 format(//1x,'Enter name of file with sample scores')
          goto 797
  796     continue
          write(*,*) ' *** FILE ALREADY EXISTS - TYPE ANOTHER NAME ***'
  797     continue
          call prompt
          read(*,2477) fileou
          open(unit=7,file=fileou,status='new',err=796)
          write(9,2007)
          write(9,2478) fileou
          end if

        write(*,2010)
        write(9,2010)
 2010 format(//1x,'Set parameter to determine type of analysis'/
     1     12x,'0= Detrended Correspondence Analysis (default)'/
     2     12x,'1= Correspondence Analysis (Reciprocal ',
     3               'Averaging)')
        call getnum(ira,0,0,1)
        if(ira.eq.1) then
               iresc=0
               mk=4
               ishort=0
               else
               iresc=4
               mk=30
               ishort=0
               short=0.0
               end if

      DO 7 II=1,MMAX
    7     INFLAG(II)=0
      write(*,2091)
      write(9,2091)
 2091 format(//1x,'Specify whether you wish to omit some samples ',
     1           'from the analysis'/
     2       12x,'0= no samples to be omitted (default)'/
     3       12x,'1= omit some samples')
        call getnum(iomit,0,0,1)
        if (iomit.eq.0) goto 350
      WRITE(*,2800)
      WRITE(9,2800)
 2800 FORMAT(1X,'ENTER NUMBERS (NOT NAMES) OF SAMPLES TO BE ',
     1'OMITTED'/1X,'ONE AT A TIME, ENDING LIST WITH A ZERO')
  200 call prompt
      READ(5,*) NONO
      IF(NONO.LT.0) GOTO 200
      IF(NONO.GT.MMAX) GOTO 200
      IF(NONO.EQ.0) GOTO 250
      WRITE(9,2801) NONO
      WRITE(*,2801) NONO
 2801 FORMAT(1X,'SAMPLE',I6,'  TO BE OMITTED')
      INFLAG(NONO)=-1
      GOTO 200
  250 WRITE(9,2802) NONO
      WRITE(*,2802) NONO
 2802 FORMAT(1X,6X,I6)
  350 continue

        write(*,2020)
        write(9,2020)
 2020 format(//1x,'Set parameter to downweight rare species'/
     1          12x,'0= No downweighting (default)'/
     2          12x,'1= Rare species downweighted')
        call getnum(iweigh,0,0,1)

        write(*,2040)
        write(9,2040)
 2040 format(//1x,'Set parameter for piecewise linear ',
     1       'tranformation of abundance values'/
     2       12x,'0= abundance values used as entered (default)'/
     3       12x,'1= species abundance values to be rescaled')
        call getnum(it,0,0,1)
      if(it.eq.0) then
          it=1
          goto 20
          end if
    5 IT=1
      AXX=0.0
      WRITE(*,2001)
      WRITE(9,2001)
 2001 FORMAT(/1X,'ENTER PIECEWISE LINEAR TRANSFORMATION IN FREE FORMAT')
      WRITE(*,2002)
      WRITE(9,2002)
 2002 FORMAT(1X,'A NEGATIVE ENTRY TERMINATES TRANSFORMATION DATA',
     1/1X,'IF NO TRANSFORMATION DESIRED, MERELY TYPE -1 0')
   10 call prompt
      READ(5,*) AX,TRANSX
      WRITE(*,2003) AX,TRANSX
      WRITE(9,2003)AX,TRANSX
 2003 FORMAT(1X,2F8.2)
      IF(AX.LT.0.0) GOTO 20
      IF (TRANSX.LT.0.0) GOTO 20
      IF (AX.LT.AXX) GOTO 5
      IT=IT+1
      BEFORE(IT)=AX
      AFTER(IT)=TRANSX
      AXX=AX
      IF(IT.LT.46) GOTO 10
      WRITE(*,2004)
      WRITE(9,2004)
 2004 FORMAT(1X,'THIS IS ENOUGH - CALCULATION PROCEEDS')
   20 IF(IT.NE.1) GOTO 23
      BEFORE(2)=0.0
      AFTER(2)=0.0
      BEFORE(3)=1.0E10
      AFTER(3)=1.0E10
      IT=3
   23 CONTINUE
      IT=IT+1
      BEFORE(1) = 0.0
      AFTER(1)= AFTER(2)
      BEFORE(IT)=1.0E10
      AFTER(IT)=AFTER(IT-1)

      CALL QUIKIN(MMAX,NMAX,IDMAX,MI,N,INAME1,INAME2,JNAME1,JNAME2,
     1IDAT,QIDAT,IBEGIN,IEND,NID,TITLE,INFLAG)
C THIS COMPLETES THE READING IN OF THE DATA
      DO 30 ID=1,NID
      AIJ=QIDAT(ID)
      IT=0
   25 IT=IT+1
      IF(BEFORE(IT).LE.AIJ) GOTO 25
      BTOP=BEFORE(IT)
      BBOT=BEFORE(IT-1)
      ATOP=AFTER(IT)
      ABOT=AFTER(IT-1)
      AIJ=ABOT+(AIJ-BBOT)*(ATOP-ABOT)/(BTOP-BBOT)
      IF(AIJ.LT.1.0E-10) AIJ=1.0E-10
      QIDAT(ID)=AIJ
   30 CONTINUE
      DO 60 J=1,N
      YEIG1(J)=0.0
   60 Y2(J)=1.0E-10
      DO 70 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      DO 65 ID=ID1,ID2
      J=IDAT(ID)
      AIJ=QIDAT(ID)
      YEIG1(J)=YEIG1(J)+AIJ
   65 Y2(J)=Y2(J)+AIJ*AIJ
   70 CONTINUE
      DO 80 J=1,N
   80 Y2(J)=YEIG1(J)**2/Y2(J)
      CALL XMAXMI(Y2,AMAX,AMIN,N)
      AMAX=AMAX/5.0
      DO 90 J=1,N
      V(J)=1.0
      IF(IWEIGH.EQ.1.AND.Y2(J).LT.AMAX) V(J)=Y2(J)/AMAX
   90 CONTINUE
C IF THERE IS REWEIGHTING TO BE DONE THIS IS NOW ACCOMPLISHED BY
C MULTIPLYING BY V(J)
      DO 100 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      DO 95 ID=ID1,ID2
      J=IDAT(ID)
   95 QIDAT(ID)=QIDAT(ID)*V(J)
  100 CONTINUE
      IF(IWEIGH.EQ.0) GOTO 110
      WRITE(9,2012)
      WRITE(9,2013) (V(J),J=1,N)
 2012 FORMAT(///1X,'WEIGHTS APPLIED TO SPECIES')
 2013 FORMAT(1X,10F6.3)
  110 continue
 2119 FORMAT(1X,'RECIPROCAL AVERAGING'/)
      DO 170 I=1,MI
  170 XEIG1(I)=1.0
      CALL XYMULT(XEIG1,ADOTJ,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      TOT=0.0
      DO 180 J=1,N
      IF(ADOTJ(J).LT.1.0E-11) ADOTJ(J)=1.0E-11
      TOT=TOT+ADOTJ(J)
  180 CONTINUE
      DO 190 J=1,N
  190 YEIG1(J)=1.0
      CALL YXMULT(YEIG1,AIDOT,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
C PRELIMINARIES ARE NOW OVER.  EIGENVECTORS ARE CALCULATED.
      CALL EIGY(XEIG1,YEIG1,EIG1,0,IRA,IRESC,SHORT,
     1MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT,Y2,Y3,Y4,Y5,
     2XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,AIDOT,ADOTJ)
      IF(IRA.EQ.0) CALL CUTUP(XEIG1,IX1,MI,MK)
      CALL EIGY(XEIG2,YEIG2,EIG2,1,IRA,IRESC,SHORT,
     1MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT,Y2,Y3,Y4,Y5,
     2XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,AIDOT,ADOTJ)
      IF(IRA.EQ.0) CALL CUTUP(XEIG2,IX2,MI,MK)
      CALL EIGY(XEIG3,YEIG3,EIG3,2,IRA,IRESC,SHORT,
     1MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT,Y2,Y3,Y4,Y5,
     2XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,AIDOT,ADOTJ)
      IF(IRA.EQ.0) CALL CUTUP(XEIG3,IX3,MI,MK)
      CALL EIGY(XEIG4,YEIG4,EIG4,3,IRA,IRESC,SHORT,
     1MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT,Y2,Y3,Y4,Y5,
     2XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,AIDOT,ADOTJ)
      WRITE(9,2100)
      CALL YXMULT(YEIG1,XEIG1,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      CALL YXMULT(YEIG2,XEIG2,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      CALL YXMULT(YEIG3,XEIG3,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      CALL YXMULT(YEIG4,XEIG4,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      DO 300 I=1,MI
      IX1(I)=IFIX(XEIG1(I)*100.0/AIDOT(I))
      IX2(I)=IFIX(XEIG2(I)*100.0/AIDOT(I))
      IX3(I)=IFIX(XEIG3(I)*100.0/AIDOT(I))
      IX4(I)=IFIX(XEIG4(I)*100.0/AIDOT(I))
      IXX1(I)=0
  300 CONTINUE
      DO 310 J=1,N
      IY1(J)=IFIX(100.0*YEIG1(J))
      IY2(J)=IFIX(100.0*YEIG2(J))
      IY3(J)=IFIX(100.0*YEIG3(J))
      IY4(J)=IFIX(100.0*YEIG4(J))
      IYY1(J)=0
  310 CONTINUE

C Next accumulate number of non-zero items
      DO 330 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      DO 320 ID=ID1,ID2
          J=IDAT(ID)
          IXX1(I)=IXX1(I)+1
          IYY1(J)=IYY1(J)+1
  320     CONTINUE
  330 CONTINUE

C VECTORS IX*,IY* NOW CONTAIN THE SCORES.  REMAINDER OF PROGRAM
C PUTS THESE OUT IN APPROPRIATE FORM.
 2100 FORMAT(/////)
      WRITE(9,2200) (TITLE(IT),IT=1,19)
      MK=MK-4
      WRITE(9,2201) IRA,IWEIGH
 2200 FORMAT(1X,19A4)
 2201 FORMAT(1X,'DECORANA OPTIONS -- ANALYSIS',I2,
     1    '   DOWNWEIGHTING',I2)
      IT=0
  270 IT=IT+1
      IF(BEFORE(IT).LT.9.9E9) GOTO 270
      ITEND=IT-1
      WRITE(9,2300) (BEFORE(IT),AFTER(IT),IT=2,ITEND)
 2300 FORMAT((1X,'TRANSFORMATION',3(6X,F7.2,F7.2)))
      WRITE(9,2101)
 2101 FORMAT(/1X,'SPECIES SCORES'/1X)
      JJ=0
      DO 450 J=1,N
      IF(ADOTJ(J).EQ.1.0E-11) GOTO 450
      JJ=JJ+1
      JNAME1(JJ)=JNAME1(J)
      JNAME2(JJ)=JNAME2(J)
      ADOTJ(JJ)=ADOTJ(J)
      IYY1(JJ)=IYY1(J)
      IY1(JJ)=IY1(J)
      IY2(JJ)=IY2(J)
      IY3(JJ)=IY3(J)
      IY4(JJ)=IY4(J)
      JNFLAG(JJ)=J
  450 CONTINUE
      N=JJ
      CALL EIGOUT(0,N,IYY0,IY1,IYY1,IY2,IYY2,IY3,IYY3,
     1IY4,IYY4,JNAME1,JNAME2,JNFLAG,EIG1,EIG2,EIG3,EIG4,ADOTJ,iaxout)
      WRITE(9,2100)
      WRITE(9,2200) (TITLE(IT),IT=1,19)
      WRITE(9,2201) IRA,IWEIGH
      WRITE(9,2300) (BEFORE(IT),AFTER(IT),IT=2,ITEND)
      WRITE(9,2102)
 2102 FORMAT(/1X,'SAMPLE SCORES - WHICH ARE WEIGHTED MEAN SPECIES ',
     1'SCORES'/1X)
      CALL EIGOUT(1,MI,IXX0,IX1,IXX1,IX2,IXX2,IX3,IXX3,
     1IX4,IXX4,INAME1,INAME2,INFLAG,EIG1,EIG2,EIG3,EIG4,AIDOT,iaxout)
      close(8)
      close(9)
      if(iaxout.eq.1) close(10)
      if(iaxout.eq.1) close(7)
      call hold
  899 continue
      write(*,*) ' *** FILE ALREADY EXISTS - TYPE ANOTHER NAME ***'
      goto 800
  999 continue
      write(*,*) ' *** FILE DOES NOT EXIST - TYPE ANOTHER NAME ***'
      goto 900
      END
C
      SUBROUTINE CUTUP(X,IX,MI,MK)
C TAKES A VECTOR X AND CUTS UP INTO (MK-4) SEGMENTS, PUTTING A
C SEGMENTED VERSION OF THE VECTOR IN IX.
      REAL X(MI)
      INTEGER IX(MI)
      MMK=MK-4
      MAXK=MK-2
      CALL XMAXMI(X,AXMAX,AXMIN,MI)
      AXBIT=(AXMAX-AXMIN)/FLOAT(MMK)
      DO 10 I=1,MI
      IAX=IFIX((X(I)-AXMIN)/AXBIT)+3
      IF(IAX.LT.3) IAX=3
      IF(IAX.GT.MAXK) IAX=MAXK
   10 IX(I)=IAX
      RETURN
      END
C
      SUBROUTINE TRANS(Y,YY,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
C THIS SUBROUTINE IS THE CRUX OF THE WHOLE PROGRAM, IN THAT IT
C TAKES A SET OF SPECIES SCORES Y AND ITERATES TO FIND A NEW SET
C OF SCORES YY.  REPEATED ITERATION OF THIS SUBROUTINE WOULD LEAD
C EVENTUALLY TO THE CORRECT SOLUTION (EXCEPT THAT THE SCORES NEED
C TO BE DIVIDED BY THE Y-TOTALS ADOTJ AT EACH ITERATION).  THE
C CALLING PROGRAM EIGY IS MADE LENGTHY BY SOME FANCY ALGEBRA PUT
C THERE TO SPEED UP THE CALCULATION.  ESSENTIALLY TRANS IS THE
C STANDARD RECIPROCAL AVERAGING ITERATION WITH EITHER DETRENDING
C WITH RESPECT TO PREVIOUSLY DERIVED AXES (IN THE CASE OF DETRENDED
C CORRESPONDENCE ANALYSIS) OR ORTHOGONALIZATION WITH RESPECT TO
C THEM (IN THE CASE OF RECIPROCAL AVERAGING).
      REAL X(MI),XEIG1(MI),XEIG2(MI),XEIG3(MI)
      REAL Y(N),YY(N),AIDOT(MI),QIDAT(NID)
      INTEGER IX1(MI),IX2(MI),IX3(MI),IDAT(NID),IBEGIN(MI),IEND(MI)
      CALL YXMULT(Y,X,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      DO 10 I=1,MI
   10 X(I)=X(I)/AIDOT(I)
      IF(NEIG.EQ.0) GOTO 200
      IF(IRA.EQ.1) GOTO 100
      CALL DETRND(X,AIDOT,IX1,MI,MK)
      IF(NEIG.EQ.1) GOTO 200
      CALL DETRND(X,AIDOT,IX2,MI,MK)
      IF(NEIG.EQ.2) GOTO 90
      CALL DETRND(X,AIDOT,IX3,MI,MK)
      CALL DETRND(X,AIDOT,IX2,MI,MK)
   90 CALL DETRND(X,AIDOT,IX1,MI,MK)
      GOTO 200
  100 A1=0.0
      DO 110 I=1,MI
  110 A1=A1+AIDOT(I)*X(I)*XEIG1(I)
      DO 120 I=1,MI
  120 X(I)=X(I)-A1*XEIG1(I)
      IF(NEIG.EQ.1) GOTO 200
      A2=0.0
      DO 130 I=1,MI
  130 A2=A2+AIDOT(I)*X(I)*XEIG2(I)
      DO 140 I=1,MI
  140 X(I)=X(I)-A2*XEIG2(I)
      IF(NEIG.EQ.2) GOTO 200
      A3=0.0
      DO 150 I=1,MI
  150 A3=A3+AIDOT(I)*X(I)*XEIG3(I)
      DO 160 I=1,MI
  160 X(I)=X(I)-A3*XEIG3(I)
  200 CALL XYMULT(X,YY,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      RETURN
      END
C
      SUBROUTINE DETRND(X,AIDOT,IX,MI,MK)
      REAL X(MI),Z(50),ZN(50),ZBAR(50),AIDOT(MI)
      INTEGER IX(MI)
C STARTS WITH A VECTOR X AND DETRENDS WITH RESPECT TO GROUPS DEFINED
C BY IX.  DETRENDING IS IN BLOCKS OF 3 UNITS AT A TIME, AND THE
C RESULT CALCULATED IS THE AVERAGE OF THE 3 POSSIBLE RESULTS THAT
C CAN BE OBTAINED, CORRESPONDING TO 3 POSSIBLE STARTING POSITIONS
C FOR THE BLOCKS OF 3.
      DO 10 K=1,MK
      Z(K)=0.0
   10 ZN(K)=0.0
      DO 20 I=1,MI
      K=IX(I)
      Z(K)=Z(K)+X(I)*AIDOT(I)
   20 ZN(K)=ZN(K)+AIDOT(I)
      MMK=MK-1
      DO 30 K=2,MMK
   30 ZBAR(K)=(Z(K-1)+Z(K)+Z(K+1))/(ZN(K-1)+ZN(K)+ZN(K+1)+1.0E-12)
      MMK=MMK-1
      DO 35 K=3,MMK
   35 Z(K)=(ZBAR(K-1)+ZBAR(K)+ZBAR(K+1))/3.0
      DO 40 I=1,MI
      K=IX(I)
   40 X(I)=X(I)-Z(K)
      RETURN
      END
C
      SUBROUTINE EIGY(X,Y,EIG,NEIG,IRA,IRESC,SHORT,
     1MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT,Y2,Y3,Y4,Y5,
     2XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,AIDOT,ADOTJ)
C EXTRACTS AN EIGENVECTOR Y WITH EIGENVALUE EIG.  THE ALGEBRA
C IS A LITTLE COMPLICATED, BUT CONSISTS ESSENTIALLY OF REPRE-
C SENTING THE TRANSFORMATION (SUBROUTINE TRANS) APPROXIMATELY
C BY A TRIDIAGONAL 4X4 MATRIX.  THE EIGENPROBLEM FOR THE
C TRIDIAGONAL MATRIX IS SOLVED AND THIS SOLUTION IS PLUGGED
C BACK IN TO OBTAIN A NEW TRIAL VECTOR.
C AFTER GETTING THE EIGENVECTOR, THE SCORES MAY BE RESCALED
C (SUBROUTINE STRTCH).
      REAL X(MI),Y(N),Y2(N),Y3(N),Y4(N),Y5(N)
      REAL XEIG1(MI),XEIG2(MI),XEIG3(MI),AIDOT(MI),ADOTJ(N)
      REAL QIDAT(NID)
      INTEGER IBEGIN(MI),IEND(MI),IDAT(NID),IX1(MI),IX2(MI),IX3(MI)
      TOT=0.0
      DO 10 J=1,N
      TOT=TOT+ADOTJ(J)
   10 Y(J)=FLOAT(J)
      Y(1)=1.1
      TOL=0.00001
      CALL TRANS(Y,Y,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      ICOUNT=0
   20 A=0.0
      DO 30 J=1,N
   30 A=A+Y(J)*ADOTJ(J)
      A=A/TOT
      EX=0.0
      DO 40 J=1,N
      AY=Y(J)-A
      EX=EX+AY*AY*ADOTJ(J)
   40 Y(J)=AY
      EX=SQRT(EX)
      DO 50 J=1,N
   50 Y(J)=Y(J)/EX
      CALL TRANS(Y,Y2,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      A=0.0
      A11=0.0
      A12=0.0
      A22=0.0
      A23=0.0
      A33=0.0
      A34=0.0
      A44=0.0
      DO 60 J=1,N
      AY=Y2(J)
      Y2(J)=AY/ADOTJ(J)
      A=A+AY
   60 A11=A11+AY*Y(J)
      A=A/TOT
      DO 70 J=1,N
      AY=Y2(J)-(A+A11*Y(J))
      A12=A12+AY*AY*ADOTJ(J)
   70 Y2(J)=AY
      A12=SQRT(A12)
      DO 80 J=1,N
   80 Y2(J)=Y2(J)/A12
      IF(ICOUNT.EQ.0) WRITE(9,1000)
 1000 FORMAT(/1X)
      WRITE(*,1011) A12,ICOUNT
      WRITE(9,1011) A12,ICOUNT
 1011 FORMAT(1X,'RESIDUAL',F10.6,'       AT ITERATION',I3)
      IF(A12.LT.TOL) GOTO 200
      IF(ICOUNT.GT.50) GOTO 200
      ICOUNT=ICOUNT+1
      CALL TRANS(Y2,Y3,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      A=0.0
      B13=0.0
      DO 90 J=1,N
      AY=Y3(J)
      Y3(J)=AY/ADOTJ(J)
      A=A+AY
      A22=A22+AY*Y2(J)
   90 B13=B13+AY*Y(J)
      A=A/TOT
      DO 100 J=1,N
      AY=Y3(J)-(A+A22*Y2(J)+B13*Y(J))
      A23=A23+AY*AY*ADOTJ(J)
  100 Y3(J)=AY
      A23=SQRT(A23)
      IF(A23.GT.TOL) GOTO 105
      A23=0.0
      GOTO 160
  105 CONTINUE
      DO 110 J=1,N
  110 Y3(J)=Y3(J)/A23
      CALL TRANS(Y3,Y4,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      A=0.0
      B14=0.0
      B24=0.0
      DO 120 J=1,N
      AY=Y4(J)
      Y4(J)=Y4(J)/ADOTJ(J)
      A=A+AY
      A33=A33+AY*Y3(J)
      B14=B14+AY*Y(J)
  120 B24=B24+AY*Y2(J)
      A=A/TOT
      DO 130 J=1,N
      AY=Y4(J)-(A+A33*Y3(J)+B14*Y(J)+B24*Y2(J))
      A34=A34+AY*AY*ADOTJ(J)
  130 Y4(J)=AY
      A34=SQRT(A34)
      IF(A34.GT.TOL) GOTO 135
      A34=0.0
      GOTO 160
  135 CONTINUE
      DO 140 J=1,N
  140 Y4(J)=Y4(J)/A34
      CALL TRANS(Y4,Y5,
     1X,NEIG,IRA,AIDOT,XEIG1,XEIG2,XEIG3,IX1,IX2,IX3,
     2MI,MK,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      DO 150 J=1,N
  150 A44=A44+Y4(J)*Y5(J)
C WE NOW HAVE THE TRIDIAGONAL REPRESENTATION OF TRANS.  SOLVE
C EIGENPROBLEM FOR TRIDIAGONAL MATRIX.
  160 AX1=1.0
      AX2=0.1
      AX3=0.01
      AX4=0.001
      DO 170 ITIMES=1,100
      AXX1=A11*AX1+A12*AX2
      AXX2=A12*AX1+A22*AX2+A23*AX3
      AXX3=A23*AX2+A33*AX3+A34*AX4
      AXX4=A34*AX3+A44*AX4
      AX1=A11*AXX1+A12*AXX2
      AX2=A12*AXX1+A22*AXX2+A23*AXX3
      AX3=A23*AXX2+A33*AXX3+A34*AXX4
      AX4=A34*AXX3+A44*AXX4
      EX=SQRT(AX1**2+AX2**2+AX3**2+AX4**2)
      AX1=AX1/EX
      AX2=AX2/EX
      AX3=AX3/EX
      AX4=AX4/EX
      IF(ITIMES.NE.(ITIMES/5)*5) GOTO 170
      EXX=SQRT(EX)
      RESI=SQRT((AX1-AXX1/EXX)**2+(AX2-AXX2/EXX)**2+
     1(AX3-AXX3/EXX)**2+(AX4-AXX4/EXX)**2)
      IF(RESI.LT.TOL*0.05) GOTO 180
  170 CONTINUE
  180 CONTINUE
      DO 190 J=1,N
  190 Y(J)=AX1*Y(J)+AX2*Y2(J)+AX3*Y3(J)+AX4*Y4(J)
      GOTO 20
  200 WRITE(9,1010) A11
      WRITE(*,1010) A11
 1010 FORMAT(1X,'EIGENVALUE',F10.5)
      IF(A12.GT.TOL) WRITE(9,1012) TOL
      IF(A12.GT.TOL) WRITE(*,1012) TOL
 1012 FORMAT(1X,'*** BEWARE ***     RESIDUAL BIGGER THAN TOLERANCE',
     1', WHICH IS',F10.5)
C WE CALCULATE X FROM Y, AND SET X TO UNIT LENGTH IF RECIPROCAL
C AVERAGING OPTION IS IN FORCE (IRA=1)
      CALL XMAXMI(Y,AYMAX,AYMIN,N)
      SIGN=1.0
      IF(-AYMIN.GT.AYMAX) SIGN=-1.0
      DO 210 J=1,N
  210 Y(J)=Y(J)*SIGN
      CALL YXMULT(Y,X,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      DO 220 I=1,MI
  220 X(I)=X(I)/AIDOT(I)
      IF(IRESC.EQ.0) GOTO 225
      IF(A11.GT.0.999) GOTO 225
      DO 223 I=1,IRESC
      MONIT=0
      IF(I.EQ.1.OR.I.EQ.IRESC) MONIT=1
      CALL STRTCH(X,Y,SHORT,MONIT,
     1MI,N,NID,AIDOT,IBEGIN,IEND,IDAT,QIDAT)
  223 CONTINUE
      EIG=A11
      RETURN
  225 AXLONG=0.0
      DO 230 I=1,MI
  230 AXLONG=AXLONG+AIDOT(I)*X(I)**2
      AXLONG=SQRT(AXLONG)
      DO 240 I=1,MI
  240 X(I)=X(I)/AXLONG
      DO 250 J=1,N
  250 Y(J)=Y(J)/AXLONG
C IT REMAINS TO SCALE Y TO UNIT WITHIN-SAMPLE STANDARD DEVIATION
      SUMSQ=0.0
      DO 260 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      AX=X(I)
      DO 255 ID=ID1,ID2
      J=IDAT(ID)
  255 SUMSQ=SUMSQ+QIDAT(ID)*(AX-Y(J))**2
  260 CONTINUE
      SD=SQRT(SUMSQ/TOT)
      IF(A11.LE.0.999) GOTO 265
      SD=AYMAX/AXLONG
      SD1=-AYMIN/AXLONG
      IF(SD1.GT.SD) SD=SD1
  265 CONTINUE
      DO 270 J=1,N
  270 Y(J)=Y(J)/SD
      EIG=A11
      RETURN
      END
C
      SUBROUTINE QUIKIN(MMAX,NMAX,NDAT,MM,N,INAME1,
     1INAME2,JNAME1,JNAME2,IDAT,QIDAT,IBEGIN,IEND,NID,TITLE,INFLAG)
C READS IN DATA MATRIX BY SAMPLES AND ROW AND COLUMN NAMES IN
C SPECIFIED FORMAT.  THE SAMPLES MUST BE IN ASCENDING NUMERICAL
C ORDER.  SECOND HALF OF SUBROUTINE CONSISTS OF AN OPTION TO DELETE
C UNWANTED SAMPLES FROM THE ANALYSIS.
      INTEGER INAME1(MMAX),INAME2(MMAX),JNAME1(NMAX),
     1JNAME2(NMAX),IDAT(NDAT)
      INTEGER IBEGIN(MMAX),IEND(MMAX),INFLAG(MMAX)
      REAL QIDAT(NDAT)
      REAL AITEM(100)
      character*20 fmt
      character*4 TITLE(20)
      INTEGER ITEM(100)
      WRITE(9,1002)
      WRITE(*,1002)
      READ(8,1000) (TITLE(IT),IT=1,20)
 1000 FORMAT(20A4)
      WRITE(*,2001) (TITLE(IT),IT=1,20)
 2001 FORMAT(//1X,19A4,A3//)
      READ(8,1001) fmt,NITEM
 1001 FORMAT(a20,48X,I2)
 1002 FORMAT(///1X,'READING DATA MATRIX FROM UNIT 8')
      if(NITEM.eq.0) read(8,*) nitem
C This line is put in to accommodate the case where number of items is entered on line 3
      if(nitem.eq.0) call hold
      ID=0
      N=0
      III=1
      ITEM(NITEM+1)=0
   40 READ(8,fmt) II,(ITEM(IT),AITEM(IT),IT=1,NITEM)
      IF(II.EQ.III) GOTO 50
      IEND(III)=ID
      IF(II.EQ.0) GOTO 100
      IBEGIN(II)=ID+1
      IF(II.LT.III) GOTO 999
      III=II
   50 IT=0
   55 IT=IT+1
      J=ITEM(IT)
      IF(J) 997,40,56
   56 IF(J.GT.N) N=J
      if(INFLAG(II).ne.-1) INFLAG(II)=1
      ID=ID+1
      IDAT(ID)=J
      AIJ=AITEM(IT)
      IF(AIJ.LT.0.0) GOTO 997
      QIDAT(ID)=AIJ
      IF(ID.GT.NDAT-3) GOTO 996
      GOTO 55
  100 MM=III
      IF(MM.GT.MMAX) GOTO 995
      IF(N.GT.NMAX) GOTO 994
      NID=ID
      IBEGIN(1)=1
C WE NOW READ THE SPECIES NAMES FOLLOWED BY THE SAMPLE NAMES
      READ(8 ,1100) (JNAME1(J),JNAME2(J),J=1,N)
      READ(8 ,1100) (INAME1(I),INAME2(I),I=1,MM)
 1100 FORMAT(20A4)
      I=0
      DO 400 II=1,MM
      IF(INFLAG(II).NE.1) GOTO 400
      I=I+1
      IBEGIN(I)=IBEGIN(II)
      IEND(I)=IEND(II)
      INAME1(I)=INAME1(II)
      INAME2(I)=INAME2(II)
      INFLAG(I)=II
  400 CONTINUE
      MM=I
      RETURN
  994 WRITE(9,1994) N,NMAX
      WRITE(*,1994) N,NMAX
 1994 FORMAT(1X,'***ABORT*** LARGEST SPECIES NUMBER ',
     1'IS',I4,'BUT SHOULD NOT EXCEED',I4)
      call hold
  995 WRITE(9,1995) MM,MMAX
      WRITE(*,1995) MM,MMAX
 1995 FORMAT(1X,'***ABORT*** LARGEST SAMPLE NUMBER ',
     1'IS',I4,'BUT SHOULD NOT EXCEED',I4)
      call hold
  996 WRITE(9,1996) II
      WRITE(*,1996) II
 1996 FORMAT(1X,'***ABORT*** NO MORE SPACE FOR DATA ',
     1'MATRIX, call holdPED AT SAMPLE',I4)
      call hold
  997 WRITE(9,1997) II
      WRITE(*,1997) II
 1997 FORMAT(1X,'***ABORT*** NEGATIVE NUMBER FOUND IN SAMPLE',I4)
      call hold
  999 WRITE(9,1999) III
      WRITE(*, 1999) III
 1999 FORMAT(1X,'***ABORT*** NON-SEQUENTIAL SAMPLE',
     1' NUMBER FOUND AFTER SAMPLE',I4)
      call hold
      END
C
      SUBROUTINE XYMULT(X,Y,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
C STARTS WITH VECTOR X AND FORMS MATRIX PRODUCT Y=AX
      REAL X(MI),Y(N),QIDAT(NID)
      INTEGER IBEGIN(MI),IEND(MI),IDAT(NID)
      DO 10 J=1,N
   10 Y(J)=0.0
      DO 30 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      AX=X(I)
      DO 20 ID=ID1,ID2
      J=IDAT(ID)
   20 Y(J)=Y(J)+AX*QIDAT(ID)
   30 CONTINUE
      RETURN
      END
C
      SUBROUTINE YXMULT(Y,X,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
C STARTS WITH VECTOR Y AND FORMS MATRIX PRODUCT X=AY
      REAL X(MI),Y(N),QIDAT(NID)
      INTEGER IBEGIN(MI),IEND(MI),IDAT(NID)
      DO 20 I=1,MI
      ID1=IBEGIN(I)
      ID2=IEND(I)
      AX=0.0
      DO 10 ID=ID1,ID2
      J=IDAT(ID)
   10 AX=AX+Y(J)*QIDAT(ID)
   20 X(I)=AX
      RETURN
      END
C
      SUBROUTINE XMAXMI(X,AXMAX,AXMIN,M)
C FORMS MAXIMUM AND MINIMUM OF X(M)
      REAL X(M)
      AXMAX=-1.0E10
      AXMIN=-AXMAX
      DO 10 I=1,M
      AX=X(I)
      IF(AX.GT.AXMAX) AXMAX=AX
      IF(AX.LT.AXMIN) AXMIN=AX
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE EIGOUT(ISAMP,M,IXX0,IX1,IXX1,IX2,IXX2,IX3,IXX3,
     1IX4,IXX4,INAME1,INAME2,INFLAG,EIG1,EIG2,EIG3,EIG4,AIDOT,iaxout)
      INTEGER IXX0(M),IX1(M),IXX1(M),IX2(M),IXX2(M),IX3(M),IXX3(M),
     1IX4(M),IXX4(M),INAME1(M),INAME2(M),INFLAG(M)
      REAL AIDOT(M)
      INTEGER IOUT(23)
C PRINTS OUT EIGENVECTORS IN A TABLE.  IX* ARE THE VECTORS IN THE
C ORDINARY ORDER.  IXX* ARE RANKED IN ORDER OF DESCENDING SIZE.
      WRITE(9,2000)
 2000 FORMAT(5X,'N',5X,'NAME    AX1  AX2  AX3  AX4    MARG TOT    N=')
      DO 300 I=1,M
      IOUT(1)=INFLAG(I)
      IOUT(2)=INAME1(I)
      IOUT(3)=INAME2(I)
      IOUT(4)=IX1(I)
      IOUT(5)=IX2(I)
      IOUT(6)=IX3(I)
      IOUT(7)=IX4(I)
      IF(ISAMP.EQ.1) then
          WRITE(9,2012) (IOUT(II),II=1,7),AIDOT(I),IXX1(I)
          if(iaxout.eq.1) WRITE(7,2012) 
     1         (IOUT(II),II=1,7),AIDOT(I),IXX1(I)
 2012 FORMAT(1X,I5,2X,2A4,1X,4I5,' |',f10.2,I6)
          else
          WRITE(9,2013) (IOUT(II),II=1,7),AIDOT(I),IXX1(I)
          if(iaxout.eq.1) WRITE(10,2013) 
     1         (IOUT(II),II=1,7),AIDOT(I),IXX1(I)
 2013 FORMAT(1X,I5,2(1X,A4),1X,4I5,' |',f10.2,I6)
          end if
  300 CONTINUE
      CALL ORDER (M,IX1,IXX1,IXX0)
      CALL ORDER (M,IX2,IXX2,IXX0)
      CALL ORDER (M,IX3,IXX3,IXX0)
      CALL ORDER (M,IX4,IXX4,IXX0)
      WRITE(9,2015)
      write(9,2001) EIG1,EIG2,EIG3,EIG4
 2015 format(//1X,'|',6X,'RANKED 1',4X,'|',6X,'RANKED 2',
     2    4X,'|',6X,'RANKED 3',4X,'|',6X,'RANKED 4',4X,'|')
 2001 FORMAT(1X,'|',4(5X,'EIG=',F5.3,4X,'|'))
      do 400 I=1,M
      I1=IXX1(I)
      I2=IXX2(I)
      I3=IXX3(I)
      I4=IXX4(I)
      IOUT(8)=INFLAG(I1)
      IOUT(9)=INAME1(I1)
      IOUT(10)=INAME2(I1)
      IOUT(11)=IX1(I1)
      IOUT(12)=INFLAG(I2)
      IOUT(13)=INAME1(I2)
      IOUT(14)=INAME2(I2)
      IOUT(15)=IX2(I2)
      IOUT(16)=INFLAG(I3)
      IOUT(17)=INAME1(I3)
      IOUT(18)=INAME2(I3)
      IOUT(19)=IX3(I3)
      IOUT(20)=INFLAG(I4)
      IOUT(21)=INAME1(I4)
      IOUT(22)=INAME2(I4)
      IOUT(23)=IX4(I4)
      IF(ISAMP.EQ.1) then
          WRITE(9,2010) (IOUT(II),II=8,23)
 2010 FORMAT(1X,4('|',I4,2X,2A4,I4),'|')
          else
          WRITE(9,2011) (IOUT(II),II=8,23)
          end if
  400 continue
 2011 FORMAT(1X,4('|',I4,2(1X,A4),I4),'|')
      RETURN
      END
C
      SUBROUTINE ORDER(M,IX,IXX,IXX0)
C TAKES A VECTOR IX AND DEFINES IXX SO THAT IXX(I)=INDEX OF THE ITH
C VALUE IN IX, RANKED FROM TOP DOWNWARDS. E.G. IF IX= 5 6 1 2 , THEN
C IXX= 2 1 4 3 , SO THAT IX(IXX(1))=6, THE LARGEST VALUE, ETC.  IXX0
C IS WORKSPACE
      INTEGER IX(M),IXX(M),IXX0(M)
      DO 10 I=1,M
      IXX(I)=I
      IXX0(I)=-IX(I)
   10 CONTINUE
      CALL ISORT2(IXX0,IXX,M)
      RETURN
      END
C
      subroutine isort2(ispec,quant,n)
C To order the ispecionary, carrying the types along too

      integer ispec(n),djx,djjx,djjjx
      integer quant(n),tjx,tjjx,tjjjx

      do 10 i=1,n
      j=i
      djx=ispec(j)
      tjx=quant(j)
    5 if(j.eq.1) goto 8
      jj=j/2
      djjx=ispec(jj)
      tjjx=quant(jj)
      if(djjx.gt.djx) goto 8
      if(djjx.eq.djx.and.tjjx.ge.tjx) goto 8
      ispec(j)=djjx
      quant(j)=tjjx
      j=jj
      goto 5
    8 ispec(j)=djx
      quant(j)=tjx
   10 continue
      i=n
      goto 14
   12 ispec(j)=djx
      quant(j)=tjx
   14 if(i.eq.1) return
      djx=ispec(i)
      tjx=quant(i)
      ispec(i)=ispec(1)
      quant(i)=quant(1)
      i=i-1
      j=1
      jj=2
   15 if(i-jj) 12,17,16
   16 djjx=ispec(jj)
      tjjx=quant(jj)
      jjj=jj+1
      djjjx=ispec(jjj)
      tjjjx=quant(jjj)
      if(djjx.gt.djjjx) goto 18
      if(djjx.eq.djjjx.and.tjjx.ge.tjjjx) goto 18
      if(djx.gt.djjjx) goto 12
      if(djx.eq.djjjx.and.tjx.ge.tjjjx) goto 12
      ispec(j)=djjjx
      quant(j)=tjjjx
      j=jjj
      jj=j*2
      goto 15
   17 djjx=ispec(jj)
      tjjx=quant(jj)
   18 if(djx.gt.djjx) goto 12
      if(djx.eq.djjx.and.tjx.ge.tjjx) goto 12
      ispec(j)=djjx
      quant(j)=tjjx
      j=jj
      jj=j*2
      goto 15
      end
C
      SUBROUTINE STRTCH(X,Y,SHORT,MONIT,
     1MI,N,NID,AIDOT,IBEGIN,IEND,IDAT,QIDAT)
C TAKES AN AXIS (X,Y) AND SCALES TO UNIT MEAN SQUARE DEV OF SPECIES
C SCORES PER SAMPLE.  AN ATTEMPT IS MADE FOR LONGER AXES (L > SHORT)
C TO SQUEEZE THEM IN AND OUT SO THAT THEY HAVE THE RIGHT MEAN SQUARE
C DEVIATION ALL THE WAY ALONG THE AXIS AND NOT ONLY ON AVERAGE.
      REAL X(MI),Y(N),AIDOT(MI),QIDAT(NID)
      REAL ZN(50),ZV(50)
      INTEGER IBEGIN(MI),IEND(MI),IDAT(NID)
      DO 200 ICOUNT=1,2
      MK=20
      CALL SEGMNT(X,Y,ZN,ZV,MI,MK,N,NID,
     1AIDOT,IBEGIN,IEND,IDAT,QIDAT)
      CALL SMOOTH(ZV,MK)
      CALL SMOOTH(ZN,MK)
      ZVSUM=0.0
      DO 50 K=1,MK
   50 ZVSUM=ZVSUM+ZV(K)/ZN(K)
      SD=SQRT(ZVSUM/FLOAT(MK))
C WE WANT MEAN WITHIN-SAMPLE SQUARE DEVIATION TO BE 1.0, SO WE DIVIDE
C EVERYTHING BY SD
      ALONG=0.0
      DO 60 I=1,MI
      AX=X(I)/SD
      X(I)=AX
   60 IF(ALONG.LT.AX) ALONG=AX
      IF(ICOUNT.EQ.1.AND.MONIT.EQ.1) WRITE(9,1000)
 1000 FORMAT(/1X)
      IF(MONIT.EQ.1) WRITE(9,1001) ALONG
 1001 FORMAT(1X,'Length of gradient',F10.3)
      DO 70 J=1,N
   70 Y(J)=Y(J)/SD
      IF(ALONG.LT.SHORT) RETURN
      IF(ICOUNT.EQ.2) RETURN
      MK=IFIX(ALONG*5.0)+1
      IF(MK.LT.10) MK=10
      IF(MK.GT.45) MK=45
      CALL SEGMNT(X,Y,ZN,ZV,MI,MK,N,NID,AIDOT,IBEGIN,IEND,IDAT,QIDAT)
      CALL SMOOTH(ZV,MK)
      CALL SMOOTH(ZN,MK)
      ZVSUM=0.0
      DO 100 K=1,MK
      AZV=1.0/SQRT(0.2/ALONG+ZV(K)/ZN(K))
      ZVSUM=ZVSUM+AZV
  100 ZV(K)=AZV
      DO 110 K=1,MK
  110 ZV(K)=ZV(K)*ALONG/ZVSUM
      IF(MONIT.EQ.1) WRITE(9,1002) (ZV(K),K=1,MK)
 1002 FORMAT(1X,'Length of segments',10F4.2)
      AZ=0.0
      ZN(1)=0.0
      DO 120 K=1,MK
      AZ=AZ+ZV(K)
  120 ZN(K+1)=AZ
      AXBIT=ALONG/FLOAT(MK)
      DO 130 J=1,N
      IAY=IFIX(Y(J)/AXBIT)+1
      IF(IAY.LT.1) IAY=1
      IF(IAY.GT.MK) IAY=MK
  130 Y(J)=ZN(IAY)+ZV(IAY)*(Y(J)/AXBIT-FLOAT(IAY-1))
      CALL YXMULT(Y,X,MI,N,NID,IBEGIN,IEND,IDAT,QIDAT)
      DO 140 I=1,MI
  140 X(I)=X(I)/AIDOT(I)
  200 CONTINUE
      RETURN
      END
C
      SUBROUTINE SMOOTH(Z,MK)
      REAL Z(MK)
C TAKES A VECTOR Z AND DOES (1,2,1)-SMOOTHING UNTIL NO BLANKS LEFT
C AND THEN 2 MORE ITERATIONS OF (1,2,1)-SMOOTHING.  IF NO BLANKS TO
C BEGIN WITH, THEN DOES 3 SMOOTHINGS, I.E. EFFECTIVELY (1,6,15,20,
C 15,6,1)-SMOOTHING.
      ISTOP=1
      DO 20 ICOUNT=1,50
      AZ2=Z(1)
      AZ3=Z(2)
      IF(AZ3.EQ.0.0) ISTOP=0
      Z(1)=0.75*AZ2+0.25*AZ3
      DO 10 K3=3,MK
      AZ1=AZ2
      AZ2=AZ3
      AZ3=Z(K3)
C      IF(AZ3.LT.0.0) ISTOP=0
C This is the bug that was discovered by Oksanen
      IF(AZ3.LE.0.0) ISTOP=0
   10 Z(K3-1)=0.5*(AZ2+0.5*(AZ1+AZ3))
      Z(MK)=0.25*AZ2+0.75*AZ3
      ISTOP=ISTOP+1
      IF(ISTOP.EQ.4) GOTO 30
   20 CONTINUE
   30 RETURN
      END
C
      SUBROUTINE SEGMNT(X,Y,ZN,ZV,MI,MK,N,NID,
     1AIDOT,IBEGIN,IEND,IDAT,QIDAT)
C GIVEN AN ORDINATION (X,Y), CALCULATES NUMBERS AND SUMMED MEAN-SQUARE
C DEVIATIONS IN MK SEGMENTS.  ZN(K) IS THE NUMBER OF SAMPLES IN SEGMENT
C K;  ZV(K) IS THE SUMMED MEAN-SQUARE DEVIATION.  (WE AIM TO MAKE ZV,
C ZN AS NEARLY EQUAL AS POSSIBLE.)
      REAL X(MI),Y(N),ZN(MK),ZV(MK),AIDOT(MI),QIDAT(NID)
      INTEGER IBEGIN(MI),IEND(MI),IDAT(NID)
      DO 10 K=1,MK
      ZN(K)=-1.0E-20
   10 ZV(K)=-1.0E-20
      CALL XMAXMI(X,AXMAX,AXMIN,MI)
      AXBIT=(AXMAX-AXMIN)/FLOAT(MK)
      DO 20 I=1,MI
   20 X(I)=X(I)-AXMIN
      DO 30 J=1,N
   30 Y(J)=Y(J)-AXMIN
      DO 50 I=1,MI
      SQCORR=0.0
      SUMSQ=2.0E-20
      ID1=IBEGIN(I)
      ID2=IEND(I)
      AX=X(I)
      DO 40 ID=ID1,ID2
      J=IDAT(ID)
      AIJ=QIDAT(ID)
      SQCORR=SQCORR+AIJ**2
   40 SUMSQ=SUMSQ+AIJ*(AX-Y(J))**2
      SQCORR=SQCORR/AIDOT(I)**2
      IF(SQCORR.GT.0.9999) SQCORR=0.9999
      SUMSQ=SUMSQ/AIDOT(I)
      K=IFIX(AX/AXBIT)+1
      IF(K.GT.MK) K=MK
      IF(K.LT.1) K=1
      ZV(K)=ZV(K)+SUMSQ
      ZN(K)=ZN(K)+1.0-SQCORR
   50 CONTINUE
      RETURN
      END
C
        subroutine screen(xlist,nscrn)
C Prints out a header for DECORANA
        character*1 blank1,answer,lowh,caph
        character*65 xlist(nscrn)
        data blank1/' '/,lowh/'h'/,caph/'H'/
        do 20 i=1,4
   20           write(*,*)
        write(*,2000)
 2000 format(17x,'                   DECORANA'//
     1       17x,' A program to perform Correspondence Analysis'/
     2       17x,'      (Detrended Correspondence Analysis '/
     3       17x,'           and Reciprocal Averaging)'//
     4       17x,'             Version 1.2, written'/
     5       17x,'   by M O Hill 1979, revised 1994 and 2012'///
     6       17x,'  Data input is in Cornell Condensed Format'/
     7       14x,'Convert to this from database format by ',
     8       'DATACORN')
        do 30 i=1,2
   30           write(*,*)
   40   continue
        write(*,2001)
 2001 format(1x,'Press <RETURN> to continue')
        read(*,1000,err=40) i
 1000 format(i6)
        return
        end

          subroutine getnum(iv,ivdef,ivmin,ivmax)
C Reads in a new value for iv, in range (ivmin,ivmax), but
C uses default value ivdef if user presses <RETURN>
          character*1 blank1,x(20),xx
          character*20 x20,blnk20
          equivalence (x20,x(1))
          data blank1/' '/
          data blnk20/'                    '/
        write(*,2000) ivdef,ivmin,ivmax
 2000 format(1x,'Press <RETURN> for default value (',i2,
     1          ')   or type new value   (Range =',i2,',',i3,')')
  100   continue
        iv=ivdef
        x20=blnk20
        call prompt
          read(*,1000) x20
 1000 format(a20)
          iiv=0
          do 200 ic=1,20
               if(x(ic).ne.blank1) goto 250
  200          continue
          goto 400
C This is the case of a blank return

  250     continue
          do 300 iic=ic,20
               xx=x(iic)
               if(xx.eq.blank1) then
                    iv=iiv
                    goto 400
                    end if
               read(xx,3000,err=999) iiiv
 3000 format(i1)
               iiv=iiv*10+iiiv
  300          continue
          iv=iiv
  400     continue
          if(iv.lt.ivmin.or.iv.gt.ivmax) goto 999
          write(9,2010) iv
 2010 format(4x,'Value =',i3)
          return
  999   continue
        write(*,2999)
 2999 format(1x,'* Inadmissible entry *')
          goto 100
          end

          subroutine prompt
C Writes a prompt;  to retain same line is compiler-dependent
C This is the GNU version
          write(*,1000)
 1000 format(' > ',$)
          end

      subroutine hold
C Asks for user input before exiting, to retain DOS window
      character*1 ch
      write(*,2000)
 2000 format(////'*** Program finished  ***'///
     1       'Press <RETURN> to exit'///
     2              '*************************')
      read(*,1000) ch
 1000 format(a1)
      stop
      end
